<?php

declare(strict_types=1);

namespace Drupal\schema_form_test\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\schema_form\SchemaFormBase;

/**
 * Example sub-form class for testing schema-based form generation.
 */
class MySubForm extends SchemaFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'my_sub_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form = $this->getSchemaForm('schema_form_test.my_sub_form');
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $this->messenger()->addMessage($this->t('Form submitted successfully.'));
  }

}
